float x = 0;
float y = 0;
float D = 100;
float time = 0;
float groundLevel = 350;

float g = 9.8;
float theta = radians(45);
float v = 3.10*sqrt(g*D);

float vx = v*cos(theta);
float vy = v*sin(theta);

void setup() {
  size(750,400);
  smooth();
  frameRate(60);
}

void draw() {
  background(255);
  drawGround();
  drawContainer();
  drawWater();
  drawBall();
  time = time + 1.0/frameRate; 
}

void drawGround() {
  line(0, groundLevel, width, groundLevel);
}

void drawContainer() {
  line(6*D, groundLevel, 6*D, groundLevel-2*D);
  line(6*D, groundLevel, 7*D, groundLevel);
  line(7*D, groundLevel, 7*D, groundLevel-2*D);
} 

void drawWater() {
  fill(0, 0, 250);
  rect(6*D, groundLevel-D, D, D);
  fill(0);
}

void drawBall() {
  x = x + vx/frameRate;
  y = y + vy/frameRate;
  vy = vy - g/frameRate;
  
  if(y < 2*D && x > 6*D-2.5 && x < 6*D+2.5){
    x = 6*D - vx/abs(vx)*3;
    vx = -vx*0.5;
  } 
  if(y < 2*D && x > 7*D-2.5 && x < 7*D+2.5) {
    x = 7*D - vx/abs(vx)*3;
    vx = -vx*0.5;
  } 
  
  if(y < 2.5) {
    y = 2.5;
    vy = -vy*0.5; // some energy is lost
    vx = 0.8*vx;
  }
  ellipse(x, groundLevel-y, 5, 5); 
}